/*
 * JBoss, Home of Professional Open Source.
 * Copyright 2006, Red Hat Middleware LLC, and individual contributors
 * as indicated by the @author tags. See the copyright.txt file in the
 * distribution for a full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.jboss.test.ws.jaxws.jbws2820;

import java.lang.reflect.InvocationTargetException;

import javax.ejb.EJBAccessException;

import org.jboss.wsf.stack.metro.InvokerEJB3;

import junit.framework.TestCase;

import com.sun.xml.ws.api.server.InstanceResolver;

/**
 * @author Andreas Wuest
 * 
 */
public class InvokerEJB3Test extends TestCase
{

   public void testHandleException()
   {
      CustomInvokerEJB3 invoker = new CustomInvokerEJB3(null);
      try
      {
         invoker.runHandleException(new EJBAccessException("authentication failure."));
         fail("expect InvokerEjB3 throws exception");
      }
      catch (InvocationTargetException e)
      {
         fail("InvocationTargetException is not expected");
      }
      catch (IllegalAccessException e)
      {
         assertTrue("authentication failure.".equals(e.getMessage()));
      }
   }

   private final class CustomInvokerEJB3 extends InvokerEJB3
   {
      public CustomInvokerEJB3(InstanceResolver resolver)
      {
         super(resolver);
      }

      public void runHandleException(Exception ex) throws InvocationTargetException, IllegalAccessException
      {
         super.handleException(ex);
      }
   }

}
